; ******************************************************************************
; *                                                                            *
; * PROGRAM: racun.asm                                                         *
; *                                                                            *
; * VERZIJA: 1.0							       *
; *                                                                            *
; * OPIS: MIPS, domaci. Program racuna vremena na poslu iz ulaznog fajla.      *
; *                                                                            *
; * AUTORI: Dejan Popovic i Caslav Nedeljkovic                                 *
; *         [046/99]        [779/99]					       * 
; *                                                                            *
; * DATUM: jun 2006                                                            *
; *                                                                            *
; ******************************************************************************


; +----------------+
; |                |
; |  STEK SEGMENT  |
; |                |
; +----------------+

stek	segment	para stack 'stack'

	; --------------
	; velicina steka
	; --------------

	db	128 dup (?)

stek	ends


; +----------------------+
; |                      |
; |   SEGMENT PODATAKA   |
; |                      |
; +----------------------+

podaci	segment	para public 'data'

	; ------------------	
	; globalne varijable
	; ------------------

     	poruka	        db 'Program za racunanje vremena',   	  0dh,0ah,'$' ; poruka sa enterom za DOS funkciju
	greska_ulazna   db 'Ne mogu da otvorim: ulazna.txt', 	  0dh,0ah,'$' ; greska pri otvaranju datoteke za DOS f-ju
	greska_izlazna  db 'Ne mogu da otvorim izlazna.txt', 	  0dh,0ah,'$' ; greska pri otvaranju datoteke za DOS f-ju
	greska_ulazna_c db 'Ne mogu da citam: ulazna.txt',   	  0dh,0ah,'$' ; greska prilikom citanja ulazne datoteke
	greska_izlazn_p db 'Ne mogu da pisem: izlazna.txt',  	  0dh,0ah,'$' ; greska prilikom pisanja izlazne datoteke
	greska_ulazna_f db 'Pogresan format: ulazna.txt',    	  0dh,0ah,'$' ; greska formata ulazne datoteke
	greska_ulazna_v	db 'Ulazna vremena nisu uzastopna!',      0dh,0ah,'$' ; greska za ulaznu datoteku (vreme pogresno)
	greska_tablica1 db 'tab: dol>odl ili otisao a nije dosao',0dh,0ah,'$' ; greska za format tabele
	greska_tablica2 db 'tab: dosao ali nije otisao!',         0dh,0ah,'$' ; greska za format tabele
	poruka_ulazna   db 'Otvorio: ulazna.txt, parsiram red> ', 0dh,0ah,'$' ; poruka o uspesnom otvaranju datoteke
	poruka_izlazna  db 'Zavrsio obradu, snimam izlaz',   	  0dh,0ah,'$' ; poruka o prelasku na ispis rezultata
	poruka_kraj	db 'Kraj rada, pritisnite neki taster za izlaz$'      ; poruka o kraju rada
	ispis_zaglavlje db '-------- Pregled pristupa -------',   0dh,0ah     ; izlazni fajl, zaglavlje fajla
	ispis_greske    db 'Broj pogresno ukucanih sifara: '                  ; izlazni fajl, broj gresaka
	ispis_csvglava  db '---------- CSV vremena ----------',   0dh,0ah     ; izlazni fajl, zaglavlje tabele vremena
	ispis_csvpolja	db 'ID_radnika, Efektivno, Ukupno',       0dh,0ah     ; izlazni fajl, kolone u csv formatu
	ispis_crlf	db 0dh, 0ah, '$'                                      ; izlazni fajl, novi red
	ispis_odjava    db '----------- Kraj CSV ------------',   0dh,0ah     ; izlazni fajl, odjava tabele sa vremenom
	ispis_separator	db ':'				 		      ; izlazni fajl, dvotacka za separator vremena
	ispis_zarez     db ', '			 		 	      ; izlazni fajl, zarez za separator CSV-a
	ispis_zapisa	db 'Broj zapisa radnika: '                            ; izlazni fajl, odjavno zaglavlje
	ispis_kraj	db '---------------------------------',   0dh,0ah     ; izlazni fajl, kraj fajla
	ulazna	        db 'ulazna.txt', 00h				      ; spisak radnika i vremena, ASCIIZ (null term)
	izlazna         db 'izlazna.txt', 00h				      ; obradjena vremena u ASCII tabeli
	handle_ulazna   dw 0						      ; file handle za ulaznu datoteku sa vremenima
	handle_izlazna  dw 0						      ; file handle za izlaznu datoteku sa obradom
	red_ulazne      dw 0						      ; brojimo red u kome se nalazimo pri citanju
	x_reda_ulazne	db 36						      ; x-pozicija na ekranu gde ispisujemo red
	y_reda_ulazne	db 1						      ; y-pozicija na ekranu gde ispisujemo red
	vrednost_ax     db 10 dup (0)					      ; ovde je bafer za ispisivanje vrednosti AX-a
	duzina_str_ax   db 0						      ; ovde ide duzina stringa vrednosti AX-a
	znak_ulazne     db 0						      ; jedan procitani znak ulazne datoteke
	id_radnika      dw 0						      ; ovde smestamo procitani id radnika iz ulazne
	vreme_akcije_m  db 0						      ; ovde smestamo procitano vreme u minutima
	vreme_akcije_s  db 0						      ; ovde smestamo procitano vreme u satima
	minutaza        dw 0						      ; za preracunavanje iz sati:minuti u minuti
	bilo_minuta	dw 0						      ; za proveru sukcesivnosti vremenskih zapisa
	broj_gresaka	db 0						      ; ovde smestamo broj procitanih gresaka
	tabela		dw 12000 dup (0)				      ; tabela za smestanje rezultata
	prazan_red	db 0						      ; indesk prvog slobodnog broja u tabeli
	pogresan_red	dw 0						      ; ID radnika gde je greska u formatu tablice
	
podaci	ends

; +----------------------+
; |                      |
; |  PROGRAMSKI SEGMENT  |
; |                      |
; +----------------------+

programskikod segment	para public 'code'
	
	; ------------------------------
	; vrednosti segmentnih registara
	; ------------------------------
	assume ss : stek,
               ds : podaci,
               cs : programskikod

	; --------------------
	; definicije procedura
	; --------------------
	
		; ------------------------------------------------------------------
		; Procedura otvara fajl preko file handle-a pozivom dos funkcije 3Dh
		; ocekuje: DS:DX - segment:offset ASCIIZ path_filename-a
		; vraca:   AX - hadle, Carry Flag - 0 ili AX - error, Carry Flag - 1
		; kvari:   AX, Carry Flag
		; ------------------------------------------------------------------
		OtvoriFajlZaCitanje proc near

		
			mov ah, 3dh	; poziv dos funkcije Open File (3dh)
			mov al, 0	; access mode (za citanje)
			int 21h		; poziv dos funkcije
			ret		; povratak iz procedure za otvaranje fajla za citanje

		OtvoriFajlZaCitanje endp

		; ------------------------------------------------------------------
		; Procedura otvara fajl preko file handle-a pozivom dos funkcije 3ch
		; ocekuje: DS:DX - segment:offset ASCIIZ path_filename-a
		; vraca:   AX - hadle, Carry Flag - 0 ili AX - error, Carry Flag - 1
		; kvari:   AX, Carry Flag
		; ------------------------------------------------------------------
		OtvoriFajlZaPisanje proc near

			push cx		; civamo vrednost cx
			xor  cx, cx	; cx - 0 svi atributi su normalni
			mov  ah, 3ch	; poziv dos funkcije Create File (3ch)
			int  21h	; poziv dos funkcije
			pop  cx		; restauriramo sadrzaj cx
			ret		; povratak iz procedure za otvaranje fajla za pisanje

		OtvoriFajlZaPisanje endp


		; ------------------------------------------------------------------
		; Procedura ispisuje poruku pozivom dos fukcije 09h
		; ocekuje: DS:DX - segment:offset stringa koji se zavrsava sa '$'-om
		; vraca:   -
		; kvari:   -
		; ------------------------------------------------------------------
		IspisiPoruku proc near
	
			push ax		; cuvamo vrednost ax
			mov  ah, 09h	; poziv dos funkcije Display String (09h)
			int  21h	; poziv dos funkcije
			pop  ax		; restauriramo sadrzaj ax
			ret		; povratak iz procedure za prikaz stringa na ekranu

		IspisiPoruku endp

		; -----------------------------------------------------------------------------------
		; Procedura cita jedan znak iz ulazne datoteke pozivom dos funkcije 3fh
		; ocekuje: -
		; vraca:   znak_ulazne - procitani znak, AX - broj znakova (1 za znak ili 0 za EOF) i
		;	   Carry Flag - greska (0 za ok, ili 1 za neku gresku pri citanju)
		; kvari:   znak_ulazne, AX, Carry Flag
		; -----------------------------------------------------------------------------------
		ProcitajZnakUlazne proc near

			push bx				; cuvamo vrednost bx
			push cx				; cuvamo vrednost cx
			push dx				; cuvamo vrednost dx
			mov  ah, 3fh			; poziv dos funkcije Read File or Device (3fh)
			mov  al, 00h			; staramo se da broj procitanih znakova bude 0 u startu
			mov  bx, handle_ulazna		; handle ulazne datoteke
			mov  cx, 01h			; count, citamo jedan znak
			mov  dx, offset znak_ulazne	; bafer u koji citamo znak
			int  21h			; poziv dos funkcije
			pop  dx				; restauriramo sadrzaj dx
			pop  cx				; restauriramo sadrzaj cx
			pop  bx				; restauriramo sadrzaj bx
			ret				; povratak iz procedure za citanje znaka iz ulaznog fajla
			
		ProcitajZnakUlazne endp

		; -----------------------------------------------------------------------------------
		; Procedura pise znakove u izlaznu datoteku pozivom dos funkcije 40h
		; ocekuje: cx - number of bytes, ds:dx - string buffer
		; vraca:   AX - broj znakova (isto kao cx ili kod greske za Carrfy Flag = 1 ) i
		;	   Carry Flag - greska (0 za ok, ili 1 za neku gresku pri citanju)
		; kvari:   AX, Carry Flag
		; -----------------------------------------------------------------------------------
		IspisiZnakoveIzlazne proc near

			push bx				; cuvamo vrednost bx
			mov  ah, 40h			; poziv dos funkcije Write to File or Device (40h)
			mov  bx, handle_izlazna		; handle izlazne datoteke
			int  21h			; poziv dos funkcije
			pop  bx				; restauriramo sadrzaj bx
			ret				; povratak iz procedure za citanje znaka iz ulaznog fajla
			
		IspisiZnakoveIzlazne endp


		; ----------------------------------------------------------------------------
		; Procedura ispisuje vrednost iz AX na ekran sukcesivnim pozivima dos funkcije
		; ocekuje: AX - vrednost koju treba ispisati
		; vraca:   - 
		; kvari:   Carry Flag
		; ----------------------------------------------------------------------------
		IspisiVrednostIzAX proc near

			push ax				; cuvamo vrednost ax
			push bx				; cuvamo vrednost bx
			push cx				; cuvamo vrednost cx
			push dx				; cuvamo vrednost dx
			push si				; cuvamo vrednost si
			mov  cx, 00h			; stavimo 1 u duzinu stringa u ax
			mov  duzina_str_ax, cl		; snimimo duzinu u memoriju
			mov  dx, 23h			; u pomocni registar ubacimo ASCII tarabe
			push dx				; gurnemo na stek tarabu za oznaku pocetka broja
			xor  dx, dx			; za slucaj da je bila nula...
			cmp  ax, 00h			; proverimo da li imamo nulu na pocetku
			je   @nula			; imamo nulu u ax, odradi samo nulu
		@opet:	xor  dx, dx			; pripremi se za deljenje sesnaestobitno ili brise ostatak u petlji
			mov  bx, 0ah			; imamo broj u ax, spremamo se da delimo sa 10
			div  bx  			; podelimo ax sa 10 u bx, u ax je koeficijent, u dx je ostatak
		@nula:	inc  cx                         ; korigujemo broj cifara u stringu
			mov  duzina_str_ax, cl		; i upisemo ga u memoriju
			add  dx, 30h			; korigujemo ostatak da prikazuje ASCII vrednost 0-9
			push dx				; bacimo ASCII cifru na stek zbog naopackog upisa
			cmp  ax, 00h			; proverimo da li imamo dalje da idemo
			jne  @opet			; ako ima nesto da se dalje deli...
			mov  si, offset vrednost_ax	; pripremimo se da pisemo od pocetka mesta za broj u memoriji
		@jos:	pop  ax				; skinemo ASCII cifru sa steka
			cmp  ax, 23h			; proverimo da li je kraj obrade
			je   @dolar			; ako je dobijena taraba, onda skoci na dodavanje dolara
			mov  es:[si],al			; posto je dobijena cifra, upisi je na lokaciju striga
			inc  si				; predji na sledeci znak stringa
			jmp  @jos			; i obradi sledecu cifru sa steka
		@dolar: mov dl, duzina_str_ax		; preuzimi duzinu stringa
			cmp dl, 01h			; proveri da nije samo jedna cifra
			jne @sufix			; ako ima vise od 1 cifre, onda samo zalepi sufiks
			inc dl				; ako je samo jedna cifra, zamisli da ima dve
			mov duzina_str_ax, dl		; i vrati u memoriju podatak o duzini stringa
			mov dl, es:[si-1]		; uzimi jedinu cifru
			mov es:[si], dl			; prekopiraj je na drugo mesto u stringu
			mov dl, 30h			; pripremi se za dodavanje vodece nule
			mov es:[si-1], dl		; dodaj vodecu nulu
			inc si				; i povecaj pokazivac na iza druge cifre
		@sufix:	mov dl, 0dh			; u pomocni registar stavi oznaku za Carriage Return
			mov es:[si], dl			; u string stavi cr
			inc si				; predji na sledeci znak stringa
			mov dl, 0ah			; u pomocni registar stavi oznaku sa Line Feed
			mov es:[si], dl			; u string stavi lf
			inc si				; predji na sledeci znak stringa
			mov dl, 24h			; u pomocni registar stavi oznaku za dolar
			mov es:[si], dl			; na kraj stringa stavi znak dolara
			pop  si				; restauriramo sadrzaj si
			pop  dx				; restauriramo sadrzaj dx
			pop  cx				; restauriramo sadrzaj cx
			pop  bx				; restauriramo sadrzaj bx
			pop  ax				; restauriramo sadrzaj ax
			ret				; povratak iz procedure za ispis vrednosti iz AX na ekran
	
		IspisiVrednostIzAx endp

		; --------------------------------------------------------------------------------
		; Procedura pronalazi da li ID iz id_radnika vec postoji u tabeli
		; ocekuje: id_radnika
		; vraca:   ax - adresa radnika za id_radnika (vrednost za si ili 0 ako nije nasao)
		; kvari:   Carry Flag
		; --------------------------------------------------------------------------------
		PronadjiID proc near

			push si				; cuvamo sadrzaj si
			push dx				; sacuvamo sadrzaj dx
			push bx				; sacuvamo sadrzaj bx
			mov  bx, id_radnika		; id koji trazimo u tabeli
			mov  si, offset tabela		; u si stavljamo ofset pocetka tabele
		@redt:	mov  ax, si			; zapamtimo gde se nalazimo
			mov  dx, es:[si]		; citamo ID tekuceg radnika iz tabele (1. word zapisa)
			cmp  dx, 00h			; gledamo da li je ID radnika = 0 (kraj tabele)
			je   @nema			; nije nasao
			cmp  dx, bx			; proveravamo da li je mozda nasao na trazenog radnika
			je   @krajp			; jeste, sve je ok, vrati indeks u ax
			add  si, 0ch			; pomeramo se za 12 bajtova (jedan zapis)
			jmp  @redt			; i prelazimo na sledeci red tabele		
		@krajp:	pop  bx				; restauriramo sadrzaj bx
			pop  dx				; restauriramo sadrzaj dx
			pop  si				; restauriramo sadrzaj si
			ret				; povratak iz procedure za pronalazenje radnika po ID-ju u tabeli
		@nema:  mov  ax,00h			; nije nasao na ID radnika do kraja tabele
			jmp  @krajp			; i skoci na kraj procedure za nalazenje radnika po ID-ju u tabeli
		
		PronadjiID endp

		; ----------------------------------------------------------
		; Procedura dodaje novi zapis za radnika u memorijsku tabelu
		; ocekuje: id_radnika, vreme_akcije_s, vreme_akcije_m
		; vraca:   - 
		; kvari:   Carry Flag
		; ----------------------------------------------------------
		NoviZapis proc near

			push ax				; cuvamo sadrzaj ax
			push si				; cuvamo sadrzaj si
			mov  si, offset tabela		; podjemo od pocetka tabele
			mov  ah, 00h			; pripremamo ax za sabiranje sa si
			mov  al, prazan_red		; jer treba da saberemo bajt sa word-om
			add  si, ax      		; pozicioniramo se na pocetak prvog slobodnog reda
			add  al, 0ch			; pomerimo ga na sledeci prazan red tabele
			mov  prazan_red, al		; i vratimo ga u memoriju iz ax
			mov  ax, id_radnika		; uzmemo id_radnika iz memorije
			mov  es:[si+00], ax		; i smestimo ga i memoriju
			mov  ax, 00h			; i postavimo u akumulator nulu za efektivno vreme novog radnika
			mov  es:[si+02], ax		; i upisemo 0 u efektivno vreme
			mov  es:[si+04], ax		; i upisemo 0 u ukupno vreme
			call PreracunajMinutazu		; preracunavamo minutazu za vreme_akcije_s i vreme_akcije_m
			mov  ax, minutaza		; uzimamo preracunatu minutazu
			mov  es:[si+06], ax		; i upisemo je u dosao
			mov  es:[si+08], ax		; upisujemo minutazu i u polje prvog dolaska
			mov  ax, 65535			; pripremimo vrednost za novo polje
			mov  es:[si+10], ax		; upisemo FFFFh u polje zadnjeg dolaska	
			xor  ax, ax			; onda u akumulator upisemo 0 za oznaku kraja tabele
			mov  es:[si+12], ax		; upisemo oznaku kraja tabele na prvu rec sledeceg sloga
			pop  si				; restauriramo sadrzaj si
			pop  ax				; restauriramo sadrzaj ax
			ret				; povratak iz procedure za dodavanje novog radnika u tabelu
		
		NoviZapis endp

		; ----------------------------------------------------------------------
		; Procedura preracunava minutazu za vreme_akcije_s i vreme_akcije_m
		; ocekuje: -
		; vraca:   -
		; kvari:   Carry Flag
		; ----------------------------------------------------------------------
		PreracunajMinutazu proc near

			push ax				; sacuvamo vrednost ax
			push bx				; sacuvamo vrednost bx
			xor  ax, ax			; u ax upisemo 0
			mov  al, vreme_akcije_s		; u al ucitamo sate
			mov  bx, 60			; u bx ucitamo broj 60 za preracunavanje u minute
			mul  bl				; pomozimo sate sa 60, u ax su minuti
			xor  bx, bx			; obrisemo bx
			mov  bl, vreme_akcije_m		; u bl ucitamo minute
			add  ax, bx			; dodamo na praracunate sate minute
			mov  minutaza, ax		; uvrednost minuta upisemo u memoriju
			pop  bx				; restauriramo sadrzaj bx
			pop  ax				; restauriramo sadrzaj ax
			ret				; povratak iz procedure za preracunavanje ukupnih dnevnih vremena
		
		PreracunajMinutazu endp

		; ----------------------------------------------------------------------------
		; Procedura preracunava ukupna vremena u tabeli jer je nastupio novi dan
		; ocekuje: -
		; vraca:   ax - 0 ako je ok, 1 - dolazak posle odlazak ili otisao a nije dosao
		;          2 - dosao je, ali nije otisao
		; kvari:   ax, Carry Flag
		; ----------------------------------------------------------------------------
		NoviDan proc near

			push bx				; cuvamo sadrzaj bx
			push cx				; cuvamo sadrzaj cx
			push si				; cuvamo sadrzaj si
			mov  si, offset tabela		; si na pocetak tabele
		@iopet:	mov  ax, es:[si]		; ID radnika u ax
			cmp  ax, 00h			; proverimo da li je kraj tabele
			je   @gotov			; ID radnika = 0, znaci da je kraj tabele
			mov  pogresan_red, ax		; zapamtimo gde smo stali sa id radnika ako dodje do greske
			mov  ax, es:[si+06]		; pogledamo da slucajno nije jos tu
			cmp  ax, 65535			; da vidimo da li je dosao prazno
			jne  @gres2			; ako ima upisano nesto ovde, znaci da je dosao ali nije otisao
			mov  ax, es:[si+04]		; Ukupno vreme u ax
			mov  bx, es:[si+08]		; prvi dolazak u bx
			mov  cx, es:[si+10]		; zadnji odlazak u cx
			cmp  bx, cx			; poredimo prvi dolazak i zadnji odlazak
			jg   @gres1			; dolazak > odlazak => greska (ili je otisao a nije dosao)
			cmp  cx, 65535			; poredimo da li je odlazak prazan?
			jne  @nasta			; odlazak <> FFFFh (a odlazak je manji ili jednak => ok, nastavi)
			cmp  bx, 65535			; odlazak = FFFFh, poredimo da li je i dolazak prazan
			je   @slede			; i dolazak = FFFFh => nista se ne menja
			jmp  @gres2			; ali dolazak <> FFFFh => greska, dosao nije otisao
		@nasta: sub  ax, bx			; ukupno vreme = ukupno vreme - prvi dolazak
			add  ax, cx			; ukupno vreme = ukupno vreme + zadnji odlazak
			mov  es:[si+04], ax		; pisemo ukupno vreme u tabelu
			mov  ax, 65535			; pripremimo reset polja tabele
			mov  es:[si+08], ax		; prvi dolazak = FFFFh
			mov  es:[si+10], ax		; zadnji odlazak = FFFFh
		@slede:	mov  ax, 0ch			; pripremamo se za sledeci zapis
			add  si, ax			; prelazimo na sledeci zapis
			jmp  @iopet			; i obradjujemo ga
		@gotov:	pop  si				; restauriramo sadrzaj si
			pop  cx				; restauriramo sadrzaj cx
			pop  bx				; restauriramo sadrzaj bx
			ret				; povratak iz procedure za preracunavanje ukupnih dnevnih vremena
		@gres1: mov  ax, 01h                    ; greska 1 - dolazak posle odlaska ili otisao a nije ni dosao
			jmp  @gotov			; i zavrsili smo
		@gres2: mov  ax, 02h                    ; greska 2 - dosao je ali nije otisao
			jmp  @gotov			; i zavrsili smo

		
		NoviDan endp

		; -------------------------------------------------------------------------------------
		; Procedura obradjuje akciju procitanu iz fajla i azurira tabelu u memoriji
		; ocekuje: id_radnika, vreme_akcije_s, vreme_akcije_m
		; vraca:   ax - o ako je ok ili 1,2 ako je neka od greska kod preracunavanja novog dana
		; kvari:   ax, Carry Flag, minutaza
		; -------------------------------------------------------------------------------------
		ObradiAkciju proc near

			push si				; cuvamo sadrzaj si
			mov  ax, id_radnika		; preuzimamo id_radnika
			cmp  ax, 00h			; proverimo da li je akcija novi dan?
			je   @dan			; ako nije novi dan, obradi radnika
			
			call PronadjiID			; prvo gledamo da li postoji vec ID upisan
			cmp  ax,00h			; proverimo da li ga je uopste nasao
			je   @novi

			mov  si, ax			; ako vec postoji u tabeli id radnika, pozicioniramo se na njega
			call PreracunajMinutazu		; preracunavamo minutazu za vreme_akcije_s i vreme_akcije_m
			mov  ax, es:[si+06h]		; ucitavamo dosao u ax
			cmp  ax, 65535			; proveravamo da li je FFFFh u dosao
			je   @dolaz			; novi dolazak na posao	
			
			mov  ax, es:[si+02]		; novi odlazak sa posla, ucitaj efektivno vreme
			sub  ax, es:[si+06]		; efektivno vreme = efektivno vreme - dolazak
			add  ax, minutaza	        ; efektivno vreme = efektivno vreme + minutaza odlaska
			mov  es:[si+02], ax		; vratimo efektivno vreme u tabelu	
			mov  ax, 65535			; pripremimo FFFFh za upis u dolazak
			mov  es:[si+06], ax		; u dolazak upisemo FFFFh
			mov  ax, minutaza		; ucitamo minutazu u ax
			mov  es:[si+10], ax		; u poslednji odlazak upisemo trenutnu minutazu
			mov  ax, 00h			; obrada je uspesna

		@krajo:	pop  si				; restauriramo sadrzaj si
			ret				; povratak iz procedure za obradu jedne akcije
		@dan:   call NoviDan			; preracunavamo ukupna vremena u celoj tabeli
			jmp  @krajo			; i zavrsavamo obradu		
		@novi:	call NoviZapis			; dodajemo novi zapis u tabeli
			mov  ax, 00h			; obrada je uspesna
			jmp  @krajo			; i zavrsavamo obradu		
		@dolaz: mov  ax, minutaza		; ucitamo trenutnu minutazu
			mov  es:[si+06], ax 		; upisemo minutazu u dosao
			mov  ax, es:[si+08]		; ucitamo vreme prvog dolaska za tekuci dan
			cmp  ax, 65535			; proverimo da li je to ujedno i prvi dolazak
			jne  @krajo			; ne radi se i o prvom dolasku na posao za tekuci dan
			mov  ax, minutaza		; ucitamo minutazu u ax
  			mov  es:[si+08], ax		; upisemo minutazu i u prvi dolazak
			mov  ax, 00h			; obrada je uspesna 
			jmp  @krajo			; i zavrsimo sa obradom dolaska
		
		ObradiAkciju endp

		; -----------------------------------------------
		; Procedura ispisuje rezultate iz tabele u fajl
		; ocekuje: -
		; vraca:   -
		; kvari:   Carry Flag, duzina_str_ax, vrednost_ax
		; -----------------------------------------------
		IspisiIzlaznuDatoteku proc near

			push ax				      ; cuvamo vrednost ax
			push bx				      ; cuvamo vrednost bx
			push si				      ; cuvamo vrednost si
			push dx				      ; cuvamo vrednost dx

			; OTVORIMO IZLAZNU DATOTEKU

			mov  dx, offset izlazna		      ; otvaramo izlaznu datoteku
			call OtvoriFajlZaPisanje     	      ; pokusavamo otvaranje datoteke
			jc   @neotv     		      ; ako je neuspeo pokusaj otvaranja izlazne datoteke
			mov  handle_izlazna, ax		      ; pamtimo handle izlazne u memoriji			

			; ISPISEMO ZAGLAVLJE SA BROJEM GRESAKA

			mov dx, offset ispis_zaglavlje        ; pripremamo ispis prvog reda izlazne datoteke
			mov cx, ispis_greske-ispis_zaglavlje  ; broj znakova prvog reda izlazne datoteke
			call IspisiZnakoveIzlazne  	      ; ispisemo zaglavlje u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_crlf	      ; pripremamo se za ispis novog reda
			mov  cx, 02h			      ; pripremamo se za ispis novog reda
			call IspisiZnakoveIzlazne  	      ; ispisemo novi red u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov dx, offset ispis_greske           ; pripremamo ispis drugog reda izlazne datoteke   
			mov cx, ispis_csvglava-ispis_greske   ; broj znakova drugog reda izlazne datoteke
			call IspisiZnakoveIzlazne  	      ; ispisemo zaglavlje u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			xor  ax, ax			      ; pripremamo se za ispis broj gresaka
			mov  al, broj_gresaka		      ; pripremamo se za ispis broj gresaka
			call IspisiVrednostIzAx		      ; pripremamo se za ispis broja gresaka
			mov  dx, offset vrednost_ax	      ; pripremamo se za ispis broja gresaka
			xor  cx, cx			      ; pripremamo se za ispis broja gresaka
			mov  cl, duzina_str_ax		      ; pripremamo se za ispis broja gresaka
			call IspisiZnakoveIzlazne  	      ; ispisemo zaglavlje u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_crlf	      ; pripremamo se za ispis novog reda
			mov  cx, 02h			      ; pripremamo se za ispis novog reda
			call IspisiZnakoveIzlazne  	      ; ispisemo novi red u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_crlf	      ; pripremamo se za ispis novog reda
			mov  cx, 02h			      ; pripremamo se za ispis novog reda
			call IspisiZnakoveIzlazne  	      ; ispisemo novi red u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov dx, offset ispis_csvglava         ; pripremamo ispis treceg reda izlazne datoteke   
			mov cx, ispis_csvpolja-ispis_csvglava ; broj znakova treceg reda izlazne datoteke
			call IspisiZnakoveIzlazne  	      ; ispisemo zaglavlje u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov dx, offset ispis_csvpolja         ; pripremamo ispis cetvrtog reda izlazne datoteke   
			mov cx, ispis_crlf-ispis_csvpolja     ; broj znakova cetvrtog reda izlazne datoteke
			call IspisiZnakoveIzlazne  	      ; ispisemo zaglavlje u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			
			; ISPISEMO TABELU

			mov si, offset tabela		      ; polazimo od pocetka tabele
		@redm:	mov ax, es:[si]			      ; uzmemo prvi ID radnika
			cmp ax, 00h			      ; proverimo da li je ID radnika 0 (kraj tabele)
			je   @odjav 			      ; ako je kraj tabele, skoci na odjavu
			call IspisiVrednostIzAx		      ; pripremamo se za ispis ID radnika
			mov  dx, offset vrednost_ax	      ; pripremamo se za ispis ID radnika
			xor  cx, cx			      ; pripremamo se za ispis ID radnika
			mov  cl, duzina_str_ax		      ; pripremamo se za ispis ID radnika
			call IspisiZnakoveIzlazne  	      ; ispisemo ID radnika u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_zarez	      ; pripremamo se za ispis zareza
			mov  cx, 02h			      ; pripremamo se za ispis zareza
			call IspisiZnakoveIzlazne  	      ; ispisemo zarez u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci


			mov  ax, es:[si+02]		      ; uzmemo efektivno vreme u minutima
			xor  dx, dx;
			mov  cx, 60			      ; pripremimo se da delimo sa 60 za sate i minute
			div  cx	         		      ; u ax su mi sati, u dx su mi minuti

			push dx				      ; treba da sacuvamo minute
			call IspisiVrednostIzAx		      ; pripremamo se za ispis efektivnog vremena u satima
			mov  dx, offset vrednost_ax	      ; pripremamo se za ispis efektivnog vremena u satima
			xor  cx, cx			      ; pripremamo se za ispis efektivnog vremena u satima
			mov  cl, duzina_str_ax		      ; pripremamo se za ispis efektivnog vremena u satima
			call IspisiZnakoveIzlazne  	      ; ispisemo efektivno vreme u satima u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_separator	      ; pripremamo se za ispis dvotacke
			mov  cx, 01h			      ; pripremamo se za ispis dvotacke
			call IspisiZnakoveIzlazne  	      ; ispisemo dvotacku u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			pop  ax				      ; podsetimo se minuta sto smo ih iz dx bacili na stek
			call IspisiVrednostIzAx		      ; pripremamo se za ispis efektivnog vremena u minutima
			mov  dx, offset vrednost_ax	      ; pripremamo se za ispis efektivnog vremena u minutima
			xor  cx, cx			      ; pripremamo se za ispis efektivnog vremena u minutima
			mov  cl, duzina_str_ax		      ; pripremamo se za ispis efektivnog vremena u minutima
			call IspisiZnakoveIzlazne  	      ; ispisemo efektivno vreme u minutima u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_zarez	      ; pripremamo se za ispis zareza
			mov  cx, 02h			      ; pripremamo se za ispis zareza
			call IspisiZnakoveIzlazne  	      ; ispisemo zarez u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  ax, es:[si+04]		      ; uzmemo ukupno vreme u minutima
			mov  cx, 3ch			      ; pripremimo se da delimo sa 60 za sate i minute
			xor  dx,dx		
			div  cx	         		      ; u ax su mi sati, u dx su mi minuti
			push dx				      ; treba da sacuvamo minute
			call IspisiVrednostIzAx		      ; pripremamo se za ispis ukupnog vremena u satima
			mov  dx, offset vrednost_ax	      ; pripremamo se za ispis ukupnog vremena u satima
			xor  cx, cx			      ; pripremamo se za ispis ukupnog vremena u satima
			mov  cl, duzina_str_ax		      ; pripremamo se za ispis ukupnog vremena u satima
			call IspisiZnakoveIzlazne  	      ; ispisemo ukupno vreme u satima u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_separator	      ; pripremamo se za ispis dvotacke
			mov  cx, 01h			      ; pripremamo se za ispis dvotacke
			call IspisiZnakoveIzlazne  	      ; ispisemo dvotacku u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			pop  ax				      ; podsetimo se minuta sto smo ih iz dx bacili na stek
			call IspisiVrednostIzAx		      ; pripremamo se za ispis ukupnog vremena u minutima
			mov  dx, offset vrednost_ax	      ; pripremamo se za ispis ukupnog vremena u minutima
			xor  cx, cx			      ; pripremamo se za ispis ukupnog vremena u minutima
			mov  cl, duzina_str_ax		      ; pripremamo se za ispis ukupnog vremena u minutima
			call IspisiZnakoveIzlazne  	      ; ispisemo ukupno vreme u minutima u izlaznu datoteku

			; OVO MOZE DA SE ISKOMENTARISE (za debug)
			; mov  dx, offset ispis_zarez	      ; ZAREZ  
			; mov  cx, 02h			      ; 
			; call IspisiZnakoveIzlazne  	      ; 
			; jc   @nepis 	                      ;
			; mov ax, es:[si+06]		      ; DOLAZAK 
			; call IspisiVrednostIzAx	      ; 
			; mov  dx, offset vrednost_ax	      ; 
			; xor  cx, cx			      ;
			; mov  cl, duzina_str_ax	      ; 
			; call IspisiZnakoveIzlazne  	      ; 
			; jc   @nepis 	                      ; 
			; mov  dx, offset ispis_zarez	      ; ZAREZ  
			; mov  cx, 02h			      ; 
			; call IspisiZnakoveIzlazne  	      ; 
			; jc   @nepis 	                      ;
			; mov ax, es:[si+08]		      ; PRVI DOLAZAK
			; call IspisiVrednostIzAx	      ; 
			; mov  dx, offset vrednost_ax	      ; 
			; xor  cx, cx			      ;
			; mov  cl, duzina_str_ax	      ; 
			; call IspisiZnakoveIzlazne  	      ; 
			; jc   @nepis 	                      ;			
			; mov  dx, offset ispis_zarez	      ; ZAREZ  
			; mov  cx, 02h			      ; 
			; call IspisiZnakoveIzlazne  	      ; 
			; jc   @nepis 	                      ;
			; mov ax, es:[si+10]		      ; ZADNJI ODLAZAK 
			; call IspisiVrednostIzAx	      ; 
			; mov  dx, offset vrednost_ax	      ; 
			; xor  cx, cx			      ;
			; mov  cl, duzina_str_ax	      ; 
			; call IspisiZnakoveIzlazne  	      ; 
			; jc   @nepis 	                      ;
			; DO OVDE, DALJE JE BITAN KOD

			mov  dx, offset ispis_crlf	      ; pripremamo se za ispis novog reda
			mov  cx, 02h			      ; pripremamo se za ispis novog reda
			call IspisiZnakoveIzlazne  	      ; ispisemo novi red u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			add  si, 0ch			      ; prelazimo na pocetaj sledeceg sloga

			jmp  @redm                            ; i odemo da ga parsiramo		



			
			; ISPISEMO ODJAVU NA KRAJU			

		@odjav:	mov dx, offset ispis_odjava           ; pripremamo ispis poslednjeg reda izlazne datoteke   
			mov cx, ispis_separator-ispis_odjava  ; broj znakova poslednjeg reda izlazne datoteke
			call IspisiZnakoveIzlazne  	      ; ispisemo zaglavlje u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_crlf	      ; pripremamo se za ispis novog reda
			mov  cx, 02h			      ; pripremamo se za ispis novog reda
			call IspisiZnakoveIzlazne  	      ; ispisemo novi red u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov dx, offset ispis_zapisa           ; pripremamo ispis odjavnog zaglavlja izlazne datoteke   
			mov cx, ispis_kraj-ispis_zapisa       ; broj znakova odjavnog reda izlazne datoteke
			call IspisiZnakoveIzlazne  	      ; ispisemo zaglavlje u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			xor  ax, ax			      ; pripremamo se za ispis broja zapisa
			mov  al, prazan_red		      ; pripremamo se za ispis broja zapisa
			mov  cx, 0ch			      ; pripremamo se za ispis broja zapisa
			div  cl				      ; pripremamo se za ispis broja zapisa
			mov  ah, 00h			      ; pripremamo se za ispis broja zapisa
			call IspisiVrednostIzAx		      ; pripremamo se za ispis broja zapisa
			mov  dx, offset vrednost_ax	      ; pripremamo se za ispis broja zapisa
			xor  cx, cx			      ; pripremamo se za ispis broja zapisa
			mov  cl, duzina_str_ax		      ; pripremamo se za ispis broja zapisa
			call IspisiZnakoveIzlazne  	      ; ispisemo zaglavlje u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_crlf	      ; pripremamo se za ispis novog reda
			mov  cx, 02h			      ; pripremamo se za ispis novog reda
			call IspisiZnakoveIzlazne  	      ; ispisemo novi red u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov  dx, offset ispis_crlf	      ; pripremamo se za ispis novog reda
			mov  cx, 02h			      ; pripremamo se za ispis novog reda
			call IspisiZnakoveIzlazne  	      ; ispisemo novi red u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci
			mov dx, offset ispis_kraj             ; pripremamo ispis treceg reda izlazne datoteke   
			mov cx, ulazna-ispis_kraj             ; broj znakova poslednjeg reda izlazne datoteke
			call IspisiZnakoveIzlazne  	      ; ispisemo odjavno zaglavlje u izlaznu datoteku
			jc   @nepis 	                      ; ako je neuspeo pokusaj pisanja po izlaznoj datoteci


		@ispik:	pop  dx			              ; restauriramo vrednost dx
			pop  si				      ; restauriramo vrednost si
			pop  bx				      ; restauriramo vrednost bx
			pop  ax				      ; restauriramo vrednost ax
			ret				      ; povratak iz procedure ispisa izlaznih podataka
		@neotv: mov  dx, offset greska_izlazna	      ; poruka o gresci pri kreiranju izlazne datoteke
			call IspisiPoruku		      ; pokusavamo da ispisemo poruku na ekranu
			jmp  @ispik		    	      ; i odlazimo na kraj		
		@nepis: mov  dx, offset greska_izlazn_p	      ; poruka o gresci pri pisanju po izlazne datoteke
			call IspisiPoruku		      ; pokusavamo da ispisemo poruku na ekranu
			jmp  @ispik		    	      ; i odlazimo na kraj		
	
		IspisiIzlaznuDatoteku endp


	; --------------
	; glavni program
	; --------------
	glavniprogram:	
        
	        ; POSTAVLJNJE SEGMENATA

		mov bx, podaci  ; postavljanje data segment-a
		mov ds, bx      ; postavljanje data segment-a
	        mov es, bx      ; postavljanje extra segment-a, potrebno zbog referenciranja tabele kao es:[si]

	@POCETAK:
    
	        ; INICIJALIZACIJA VIDEO MODA 80x35 I BRISANJE EKRANA
	        mov  ah, 0
	        mov  al, 03h
	        int  10h

		; ispisujemo poruku o tome sta program radi
		mov dx, offset poruka		; poruka o tome sta program radi
		call IspisiPoruku		; pokusavamo da ispisemo poruku na ekranu

		; OTVARAMO ULAZNU DATOTEKU
		mov  dx, offset ulazna 		; otvaramo datoteku
		call OtvoriFajlZaCitanje	; pokusavamo otvaranje datoteke
		jc   @NeMoguDaOtvorimUlaznu	; ako je neuspeo pokusaj otvaranja ulazne datoteke
		mov  dx, offset poruka_ulazna 	; poruka ako je uspelo otvaranje datoteke
		call IspisiPoruku		; pokusavamo da ispisemo poruku na ekranu
		mov  handle_ulazna, ax		; pamtimo handle ulazne u memoriji

		;OVDE SADA PARSIRAMO RADNIKE!
		;citamo prvi znak ulazne	; ovo je prvi znak u redu ulazne datoteke
		
	@CitajRedUlazne:	
		mov  cx,red_ulazne		; krecemo od prvog reda ulazne datoteke
		inc  cx				; povecavamo broj rekuceg reda ulazne datoteke
		mov  red_ulazne, cx		; i vracamo ga u memoriju 

		; goto xy, za tekstualni kursor!
		mov  dh, y_reda_ulazne		; uzimamo y koordinatu za kursor
		mov  dl, x_reda_ulazne		; uzimamo x koordinatu za kursor
		mov  ah, 02h			; BIOS poziv, set cursor position
		mov  bx, 0			; video page je 0
		int  10h			; BIOS video interrupt
		
		; samo za debbug
		; mov  ah,0			; cekamo pritisak na taster
		; int  16h			; cekamo pritisak na taster
		; dalje nije debbug
				
		mov  ax, cx			; pripremi broj tekuceg reda ulazne za ispis
		call IspisiVrednostIzAx		; pretvori broj iz ax u string za ispis
		mov  dx, offset vrednost_ax	; pripremi string sa brojem iz ax za prikaz
		call IspisiPoruku		; prikazi string sa brojem iz ax

		call ProcitajZnakUlazne		; pokusavamo da procitamo znak iz ulazne datoteke
		jc   @NeMoguDaCitamUlaznu	; ako je neuspeo pokusaj citanja ulazne datoteke
		cmp  ax, 0			; proveravamo broj procitanih znakova
		je   @PisiIzlaznuDatoteku	; ako je doslo do EOF-a na pocetku reda, onda predji na pisanje jer je sve ok

		; parsiramo prvi procitani znak
		mov  al, znak_ulazne		; pogledamo koji je znak procitan
		cmp  al, 23h			; proverimo da nije # za gresku
		je   @ProcitaoKodGreske		; ako je bila greska, onda povecaj kod i idi dalje

		; parsiramo ID Radnika
		mov  bx, 00h			; u bx ide Id radnika
		mov  cx, 04h			; iteracija se odnosi na 4 znaka procitana iz ulaznog fajla
	@CitajIDRadnika:
 		; proveravamo da li je broj
		cmp  al, 39h			; testiramo na cifru 9
		jg   @PogresanFormatUlazne	; ako je vece od ASCII 9, onda je pogresan format
		cmp  al, 30h			; testiramo na cifru 0
		jl   @PogresanFormatUlazne	; ako je manje od ASCII 0, onda je pogresan format
		sub  al, 30h			; pretvorimo ASCII cifru u numericku vrednost
		push ax				; treba nam za mnozenje ax
		mov  ax, bx			; ID stavimo u bx, odnosno id radnika
		mov  bx, 0ah			; u bx stavimo 10 za 16-bitno mnozenje
		xor  dx, dx			; pripremimo dx za prihvat rezultata
		mul  bx				; ax pomnozimo sa 10 iz bx i rezultat je u dx:ax, ostajemo u okviru ax
		mov  bx, ax			; vratimo rezultat u bx
		pop  ax				; vratimo broj u al
		xor  ah, ah			; u ah ide nula zbog sabiranja
		add  bx, ax			; dodamo sledecu decimalnu cifru na bx
		call ProcitajZnakUlazne		; pokusavamo da procitamo znak iz ulazne datoteke
		jc   @NeMoguDaCitamUlaznu	; ako je neuspeo pokusaj citanja ulazne datoteke
		cmp  ax, 0			; proveravamo broj procitanih znakova
		je   @PogresanFormatUlazne	; ako je doslo do EOF-a u citanju ID-ja onda je pogresan format
		mov al, znak_ulazne		; uzmemo procitani znak
		loop @CitajIDRadnika		; i iteriramo dok se ne procitaju sve cetiri (cx) cifre iz fajla
		mov  id_radnika, bx		; smestamo nadjeni id radnika u memoriju
		cmp  bx, 00h			; proveravamo da li je ID radnika =0 (novi dan)
		jne  @CuvajMinute		; ako je pravi radnik, nastavi sa citanjem formata
		mov  bilo_minuta,00h		; akoje novi dan resetujemo staru minutazu
		jmp  @CitajZarez		; i nastavimo sa citanjem formata od zareza

	@CuvajMinute:
		; cuvamo staru minutazu
		call PreracunajMinutazu		; izracunavamo minutazu prema starim vrednostima sati i minuta
		mov  bx, minutaza
		mov  bilo_minuta, bx 		; prijavimo da je toliko bilo minuta

	@CitajZarez:
		; preskacemo zarez
		cmp  al, 2ch			; smestamo ASCII kod zareza u registar
		jne  @PogresanFormatUlazne	; ako nije zarez posle id radnika, onda je pogresan format
		call ProcitajZnakUlazne		; pokusavamo da procitamo znak iz ulazne datoteke
		jc   @NeMoguDaCitamUlaznu	; ako je neuspeo pokusaj citanja ulazne datoteke
		cmp  ax, 0			; proveravamo broj procitanih znakova
		je   @PogresanFormatUlazne	; ako je doslo do EOF-a u citanju broja sati onda je pogresan format
		mov al, znak_ulazne		; uzmemo procitani znak

		; parsiramo vreme (sate)
		mov bx, 00h			; u bx ide broj sati, bl je vazan
		mov cx, 02h			; iteracija se odnosi na 2 znaka procitana iz ulaznog fajla
	@CitajSate:		
 		; proveravamo da li je broj
		cmp  al, 39h			; testiramo na cifru 9
		jg   @PogresanFormatUlazne	; ako je vece od ASCII 9, onda je pogresan format
		cmp  al, 30h			; testiramo na cifru 0
		jl   @PogresanFormatUlazne	; ako je manje od ASCII 0, onda je pogresan format
		sub  al, 30h			; pretvorimo ASCII cifru u numericku vrednost
		push ax				; treba nam za mnozenje ax
		mov  ax, bx			; ID stavimo u bx
		mov  dl, 0ah			; u dx stavimo 10 za mnozenje
		mul  dl				; al pomnozimo sa 10 iz dl i rezultat je u ax
		mov  bx, ax			; vratimo rezultat u bx
		pop  ax				; vratimo broj u al
		xor  ah, ah			; u ah ide nula zbog sabiranja
		add  bx, ax			; dodamo sledecu decimalnu cifru na bx
		call ProcitajZnakUlazne		; pokusavamo da procitamo znak iz ulazne datoteke
		jc   @NeMoguDaCitamUlaznu	; ako je neuspeo pokusaj citanja ulazne datoteke
		cmp  ax, 0			; proveravamo broj procitanih znakova
		je   @PogresanFormatUlazne	; ako je doslo do EOF-a u citanju broja sati onda je pogresan format
		mov al, znak_ulazne		; uzmemo procitani znak
		loop @CitajSate 		; i iteriramo dok se ne procitaju obe (cx) cifre iz fajla
		mov  vreme_akcije_s, bl		; smestamo nadjeni broj sati u memoriju

		; preskacemo dvotacku
		cmp  al, 3ah			; smestamo ASCII kod dvotacke u registar
		jne  @PogresanFormatUlazne	; ako nije dvotacka posle broja sati, onda je pogresan format
		call ProcitajZnakUlazne		; pokusavamo da procitamo znak iz ulazne datoteke
		jc   @NeMoguDaCitamUlaznu	; ako je neuspeo pokusaj citanja ulazne datoteke
		cmp  ax, 0			; proveravamo broj procitanih znakova
		je   @PogresanFormatUlazne	; ako je doslo do EOF-a u citanju broja minuta onda je pogresan format
		mov al, znak_ulazne		; uzmemo procitani znak

		; parsiramo vreme (minute)
		mov bx, 00h			; u bx ide broj sati, bl je vazan
		mov cx, 02h			; iteracija se odnosi na 2 znaka procitana iz ulaznog fajla
	@CitajMinute:		
 		; proveravamo da li je broj
		cmp  al, 39h			; testiramo na cifru 9
		jg   @PogresanFormatUlazne	; ako je vece od ASCII 9, onda je pogresan format
		cmp  al, 30h			; testiramo na cifru 0
		jl   @PogresanFormatUlazne	; ako je manje od ASCII 0, onda je pogresan format
		sub  al, 30h			; pretvorimo ASCII cifru u numericku vrednost
		push ax				; treba nam za mnozenje ax
		mov  ax, bx			; ID stavimo u bx
		mov  dl, 0ah			; u dx stavimo 10 za mnozenje
		mul  dl				; al pomnozimo sa 10 iz dl i rezultat je u ax
		mov  bx, ax			; vratimo rezultat u bx
		pop  ax				; vratimo broj u al
		xor  ah, ah			; u ah ide nula zbog sabiranja
		add  bx, ax			; dodamo sledecu decimalnu cifru na bx
		call ProcitajZnakUlazne		; pokusavamo da procitamo znak iz ulazne datoteke
		jc   @NeMoguDaCitamUlaznu	; ako je neuspeo pokusaj citanja ulazne datoteke
		cmp  ax, 0			; proveravamo broj procitanih znakova
		je   @PogresanFormatUlazne	; ako je doslo do EOF-a u citanju broja minuta onda je pogresan format
		mov al, znak_ulazne		; uzmemo procitani znak
		loop @CitajMinute 		; i iteriramo dok se ne procitaju obe (cx) cifre iz fajla
		mov  vreme_akcije_m, bl		; smestamo nadjeni broj minuta u memoriju		

		; proverimo sukcesivnost
		call PreracunajMinutazu
		mov  ax, minutaza
		cmp  ax, bilo_minuta
		;
		; +--------------------------------------+
		; | Modifikacija za racunanje novog dana |
		; +--------------------------------------+
		;
		; KADA BI SE VREME OKIDALO NA PROMENU VREMENA SA VECEG NA MANJE
		; ONDA BI OVDE TREBALO DA SE UMESTO SKOKA NA PRIJAVU GRESKE (jl @PogresnoVremeUlazne)
		; STAVI LABELA NA OBRADU AKCIJE @ObradiAkciju i da se programski
		; ODRADI SLEDECE :
		;  
		; jge  @ObradiAkciju
		; mov  bx,00h
		; mov  bilo_minuta,bx
		; call NoviDan
		; 	
		jl   @PogresnoVremeUlazne	; ako je procitano vreme manje od zapamcenog, javi gresku
		

		;
		; +--------------------------------------+
		; | Modifikacija za racunanje novog dana |
		; +--------------------------------------+
		;
		;	@ObradiAkciju: 
		;

		; OVDE IDE OBRADA AKCIJE
		; imamo ucitane sve tri vrednosti
		; kao numericke vrednosti u memoriji
		; id_radnika, vreme_akcije_s, vreme_akcije_m
		; sad ide ono glavno - obrada ulazne tabele

		call ObradiAkciju
		cmp  ax, 01h			; proverimo da li je bila greska kod obrade akcije
		je   @GreskaTablica1		; jeste, ispisi gresku
		cmp  ax, 02h			; proverimo da li je bila greska kod obrade akcije
		je   @GreskaTablica2		; jeste, ispisi gresku

		jmp  @ProveriKrajReda		; i preskocimo cr/lf na kraju reda

	@ProcitaoKodGreske:
		mov  al, broj_gresaka		; uzimamo procitani broj gresaka
		inc  al				; povecavamo ga za jedan
		mov  broj_gresaka, al		; vracamo ga u memoriju
		jmp  @ProcitajKrajReda		; i preskocimo cr/lf na kraju reda

	@ProcitajKrajReda:
		call ProcitajZnakUlazne		; pokusavamo da procitamo prvi znak kraja reda (cr) iz ulazne datoteke
		jc   @NeMoguDaCitamUlaznu	; ako je neuspeo pokusaj citanja ulazne datoteke
		cmp  ax, 0			; proveravamo broj procitanih znakova
		je   @PogresanFormatUlazne	; ako je doslo do EOF-a pri citanju cr-a, onda je pogresan format ulazne
	@ProveriKrajReda:
		mov  al, znak_ulazne		; pogledamo koji je znak procitan
		cmp  al, 0dh			; proverimo da li je prvi znak kraja reda 0dh (Carriage Return)
		jne  @PogresanFormatUlazne	; ako prvi znak kraja reda nije bio cr onda je pogresan format ulazne
		call ProcitajZnakUlazne		; pokusavamo da procitamo drugi znak kraja reda (lf) iz ulazne datoteke
		jc   @NeMoguDaCitamUlaznu	; ako je neuspeo pokusaj citanja ulazne datoteke
		cmp  ax, 0			; proveravamo broj procitanih znakova
		je   @PogresanFormatUlazne	; ako je doslo do EOF-a pri citanju lf-a, onda je pogresan format ulazne
		mov  al, znak_ulazne		; pogledamo koji je znak procitan
		cmp  al, 0ah			; proverimo da li je drugi znak kraja reda 0ah (Line Feed)
		jne  @PogresanFormatUlazne	; ako prvi znak kraja reda nije bio cr onda je pogresan format ulazne	
		jmp  @CitajRedUlazne		; sve je ok, preskocio cr/lf, citaj prvi znak sledeceg reda ulazne datoteke
		
	@NeMoguDaOtvorimUlaznu:
		mov  dx, offset greska_ulazna	; poruka o gresci pri otvaranju ulazne datoteke koju hocemo da ispisemo
		call IspisiPoruku		; pokusavamo da ispisemo poruku na ekranu
		jmp  @KRAJ			; i odlazimo na kraj		

	@NeMoguDaCitamUlaznu:
		mov  ax, red_ulazne		; pripremi broj tekuceg reda ulazne za ispis
		call IspisiVrednostIzAx		; pretvori broj iz ax u string za ispis
		mov  dx, offset vrednost_ax	; pripremi string sa brojem iz ax za prikaz
		call IspisiPoruku		; prikazi string sa brojem iz ax
		mov  dx, offset greska_ulazna_c ; poruka o gresci prilikom citanja ulazne datoteke
		call IspisiPoruku		; pokusavamo da ispisemo poruku na ekranu
		jmp  @KRAJ			; i odlazimo na kraj

	@PogresanFormatUlazne:
		mov  ax, red_ulazne		; pripremi broj tekuceg reda ulazne za ispis
		call IspisiVrednostIzAx		; pretvori broj iz ax u string za ispis
		mov  dx, offset vrednost_ax	; pripremi string sa brojem iz ax za prikaz
		call IspisiPoruku		; prikazi string sa brojem iz ax
		mov  dx, offset greska_ulazna_f ; poruka o gresci formata prilikom citanja ulazne datoteke
		call IspisiPoruku		; pokusavamo da ispisemo poruku na ekranu
		jmp  @KRAJ			; i odlazimo na kraj

	@PogresnoVremeUlazne:
		mov  ax, red_ulazne		; pripremi broj tekuceg reda ulazne za ispis
		call IspisiVrednostIzAx		; pretvori broj iz ax u string za ispis
		mov  dx, offset vrednost_ax	; pripremi string sa brojem iz ax za prikaz
		call IspisiPoruku		; prikazi string sa brojem iz ax
		mov  dx, offset greska_ulazna_v ; poruka o gresci uzastopnosti vremena prilikom citanja ulazne datoteke
		call IspisiPoruku		; pokusavamo da ispisemo poruku na ekranu
		jmp  @KRAJ			; i odlazimo na kraj

	@GreskaTablica1:
		mov  ax, pogresan_red		; pripremi broj tekuceg reda ulazne za ispis
		call IspisiVrednostIzAx		; pretvori broj iz ax u string za ispis
		mov  dx, offset vrednost_ax	; pripremi string sa brojem iz ax za prikaz
		call IspisiPoruku		; prikazi string sa brojem iz ax
		mov  dx, offset greska_tablica1 ; poruka o gresci da je dolazak posle odlaska ili otisao a nije dosao
		call IspisiPoruku		; pokusavamo da ispisemo poruku na ekranu
		jmp  @KRAJ			; i odlazimo na kraj

	@GreskaTablica2:
		mov  ax, pogresan_red		; pripremi broj tekuceg reda ulazne za ispis
		call IspisiVrednostIzAx		; pretvori broj iz ax u string za ispis
		mov  dx, offset vrednost_ax	; pripremi string sa brojem iz ax za prikaz
		call IspisiPoruku		; prikazi string sa brojem iz ax
		mov  dx, offset greska_tablica2 ; poruka o gresci u tablici da je dosao ali nije otisao
		call IspisiPoruku		; pokusavamo da ispisemo poruku na ekranu
		jmp  @KRAJ			; i odlazimo na kraj

	@PisiIzlaznuDatoteku:
		mov  dx, offset poruka_izlazna	; poruka o tome sta program radi (pise izlaznu datoteku)
		call IspisiPoruku

		; prvo za svaki slucaj uradimo novi dan
		call NoviDan
		cmp  ax, 01h			; proverimo da li je bila greska kod obrade akcije
		je   @GreskaTablica1		; jeste, ispisi gresku
		cmp  ax, 02h			; proverimo da li je bila greska kod obrade akcije
		je   @GreskaTablica2		; jeste, ispisi gresku

		; OVDE PISEMO IZLAZNU DATOTEKU		
		
		call IspisiIzlaznuDatoteku      ; ispisujemo izlaznu datoteku
		jmp @KRAJ			; i odlazimo na kraj
		
	@KRAJ:

		; besmislena cekalica i kontrola
		mov  dx, offset poruka_kraj     ; poruka o zavrsetku rada programa
		call IspisiPoruku		; pokusavamo da ispisemo poruku na ekranu

		; ispisujemo jednu diodicu
	        mov ah, 09h    ; ugasena dioda, write character with attribute
	        mov bl, 32     ; video attribute (16*background color+foreground color+128 for blink)
		mov bh, 0      ; video page
		mov al, 7      ; ASCII character
		mov cx, 1      ; Character count
	        int 10h        ; BIOS Video Services

	@OznaK: mov ah,0h   ; cekamo da korisnik pritisne taster
        	int 16h


		; besmislena cekalica i kontrola

	        ; INICIJALIZACIJA VIDEO MODA 80x35 I BRISANJE EKRANA
	        mov ah,0
	        mov al,03h
	        int 10h
		
		; Terminate program with return code
		mov ah,4ch
		mov al,00h
		int 21h


programskikod ends
end glavniprogram
